package java.io;

public class StringWriter extends Writer {
   private StringBuffer buf;
   private boolean isClosed = false;

   private void ensureOpen() {
   }

   public StringWriter() {
      this.buf = new StringBuffer();
      super.lock = this.buf;
   }

   public StringWriter(int var1) {
      if (var1 < 0) {
         throw new IllegalArgumentException("Negative buffer size");
      } else {
         this.buf = new StringBuffer(var1);
         super.lock = this.buf;
      }
   }

   public void write(int var1) {
      this.ensureOpen();
      this.buf.append((char)var1);
   }

   public void write(char[] var1, int var2, int var3) {
      this.ensureOpen();
      if (var2 >= 0 && var2 <= var1.length && var3 >= 0 && var2 + var3 <= var1.length && var2 + var3 >= 0) {
         if (var3 != 0) {
            this.buf.append(var1, var2, var3);
         }
      } else {
         throw new IndexOutOfBoundsException();
      }
   }

   public void write(String var1) {
      this.ensureOpen();
      this.buf.append(var1);
   }

   public void write(String var1, int var2, int var3) {
      this.ensureOpen();
      this.buf.append(var1.substring(var2, var2 + var3));
   }

   public String toString() {
      return this.buf.toString();
   }

   public StringBuffer getBuffer() {
      return this.buf;
   }

   public void flush() {
      this.ensureOpen();
   }

   public void close() throws IOException {
      this.isClosed = true;
   }
}
